program checkelf;
{$ifdef FPC}{$mode objfpc}{$h+}{$endif}
{$ifdef mswindows}{$apptype console}{$endif}
uses
 {$ifdef FPC}{$ifdef unix}cthreads,cwstring,{$endif}{$endif}
 sysutils;
 
 var
 thefile: string;
 theresult : integer;
 
function CheckELF(ObjectFilename : pchar): integer;
var
 F: file; 
 BufferTag: array[0..4] of byte; 
 x, y : integer;
 begin
// From Wikipedia, ELF format: 
// Read the first four bytes. If they are equal to \x7fELF, it's an ELF file. 
// The ELF magic number is 0x7f454C46 (0x7f + "ELF") 
// The 5th byte is 1 for a 32 bit executable, 2 for a 64 bit executable.
 
   //SetLength(BufferTag, 500);
 
   AssignFile(F, ObjectFilename); 
   FileMode:=fmOpenRead + fmShareDenyNone;
   Reset(F, 1); 
   BlockRead(F, BufferTag, SizeOf(BufferTag)); 
   CloseFile(F); 
 
    x := 0;
    y := 0;
  while x < 4 do
  begin
   y := y + BufferTag[x];
   inc(x);
   end; 
   
   result := -1;
   
  if y = 342 then // it is a ELF
  begin
   x := BufferTag[4];
   
   if x = 2 then
     result := x; 
   if x = 1 then
     result := x;    
  
 end;
 {
  x := 0;
  while x < 5 do
  begin
   writeln(inttostr(x) +' = ' + inttostr((BufferTag[x]))); 
   inc(x);
   end; 
 } 
   end; 
 
begin
 writeln('Enter the full path of a file...');
 writeln('And press [Enter]...');
 
 readln(thefile);

 theresult := CheckELF(pchar(thefile));

if theresult = 1 then
 writeln( thefile + ' has a ELF 32 bit signature.')
 else 
if theresult = 2 then
 writeln( thefile + ' has a ELF 64 bit signature.')
 else
 writeln( thefile + ' has a no ELF signature.')


end.
